<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC https://civicrm.org/licensing
 *
 * Generated from com.drastikbydesign.stripe/xml/schema/CRM/Stripe/StripePaymentintent.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:b67646ad6a172031ee010ed01449d20e)
 */
use CRM_Stripe_ExtensionUtil as E;

/**
 * Database access object for the StripePaymentintent entity.
 */
class CRM_Stripe_DAO_StripePaymentintent extends CRM_Core_DAO {
  const EXT = E::LONG_NAME;
  const TABLE_ADDED = '';

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  public static $_tableName = 'civicrm_stripe_paymentintent';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  public static $_log = TRUE;

  /**
   * Unique ID
   *
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $id;

  /**
   * The Stripe PaymentIntent/SetupIntent/PaymentMethod ID
   *
   * @var string|null
   *   (SQL type: varchar(255))
   *   Note that values will be retrieved from the database as a string.
   */
  public $stripe_intent_id;

  /**
   * FK ID from civicrm_contribution
   *
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $contribution_id;

  /**
   * Foreign key to civicrm_payment_processor.id
   *
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $payment_processor_id;

  /**
   * Description of this paymentIntent
   *
   * @var string
   *   (SQL type: varchar(255))
   *   Note that values will be retrieved from the database as a string.
   */
  public $description;

  /**
   * The status of the paymentIntent
   *
   * @var string
   *   (SQL type: varchar(25))
   *   Note that values will be retrieved from the database as a string.
   */
  public $status;

  /**
   * An identifier that we can use in CiviCRM to find the paymentIntent if we do not have the ID (eg. session key)
   *
   * @var string
   *   (SQL type: varchar(255))
   *   Note that values will be retrieved from the database as a string.
   */
  public $identifier;

  /**
   * FK to Contact
   *
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $contact_id;

  /**
   * When was paymentIntent created
   *
   * @var string|null
   *   (SQL type: timestamp)
   *   Note that values will be retrieved from the database as a string.
   */
  public $created_date;

  /**
   * Flags associated with this PaymentIntent (NC=no contributionID when doPayment called)
   *
   * @var string
   *   (SQL type: varchar(100))
   *   Note that values will be retrieved from the database as a string.
   */
  public $flags;

  /**
   * HTTP referrer of this paymentIntent
   *
   * @var string
   *   (SQL type: varchar(255))
   *   Note that values will be retrieved from the database as a string.
   */
  public $referrer;

  /**
   * Extra data collected to help with diagnostics (such as email, name)
   *
   * @var string
   *   (SQL type: varchar(255))
   *   Note that values will be retrieved from the database as a string.
   */
  public $extra_data;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civicrm_stripe_paymentintent';
    parent::__construct();
  }

  /**
   * Returns localized title of this entity.
   *
   * @param bool $plural
   *   Whether to return the plural version of the title.
   */
  public static function getEntityTitle($plural = FALSE) {
    return $plural ? E::ts('Stripe Paymentintents') : E::ts('Stripe Paymentintent');
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('ID'),
          'description' => E::ts('Unique ID'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_stripe_paymentintent.id',
          'table_name' => 'civicrm_stripe_paymentintent',
          'entity' => 'StripePaymentintent',
          'bao' => 'CRM_Stripe_DAO_StripePaymentintent',
          'localizable' => 0,
          'readonly' => TRUE,
          'add' => NULL,
        ],
        'stripe_intent_id' => [
          'name' => 'stripe_intent_id',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Stripe Intent ID'),
          'description' => E::ts('The Stripe PaymentIntent/SetupIntent/PaymentMethod ID'),
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_stripe_paymentintent.stripe_intent_id',
          'table_name' => 'civicrm_stripe_paymentintent',
          'entity' => 'StripePaymentintent',
          'bao' => 'CRM_Stripe_DAO_StripePaymentintent',
          'localizable' => 0,
          'add' => NULL,
        ],
        'contribution_id' => [
          'name' => 'contribution_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('Contribution ID'),
          'description' => E::ts('FK ID from civicrm_contribution'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_stripe_paymentintent.contribution_id',
          'table_name' => 'civicrm_stripe_paymentintent',
          'entity' => 'StripePaymentintent',
          'bao' => 'CRM_Stripe_DAO_StripePaymentintent',
          'localizable' => 0,
          'add' => NULL,
        ],
        'payment_processor_id' => [
          'name' => 'payment_processor_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('Payment Processor'),
          'description' => E::ts('Foreign key to civicrm_payment_processor.id'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_stripe_paymentintent.payment_processor_id',
          'table_name' => 'civicrm_stripe_paymentintent',
          'entity' => 'StripePaymentintent',
          'bao' => 'CRM_Stripe_DAO_StripePaymentintent',
          'localizable' => 0,
          'FKClassName' => 'CRM_Financial_DAO_PaymentProcessor',
          'pseudoconstant' => [
            'table' => 'civicrm_payment_processor',
            'keyColumn' => 'id',
            'labelColumn' => 'name',
          ],
          'add' => NULL,
        ],
        'description' => [
          'name' => 'description',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Description'),
          'description' => E::ts('Description of this paymentIntent'),
          'required' => FALSE,
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_stripe_paymentintent.description',
          'table_name' => 'civicrm_stripe_paymentintent',
          'entity' => 'StripePaymentintent',
          'bao' => 'CRM_Stripe_DAO_StripePaymentintent',
          'localizable' => 0,
          'add' => NULL,
        ],
        'status' => [
          'name' => 'status',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Status'),
          'description' => E::ts('The status of the paymentIntent'),
          'required' => FALSE,
          'maxlength' => 25,
          'size' => CRM_Utils_Type::MEDIUM,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_stripe_paymentintent.status',
          'table_name' => 'civicrm_stripe_paymentintent',
          'entity' => 'StripePaymentintent',
          'bao' => 'CRM_Stripe_DAO_StripePaymentintent',
          'localizable' => 0,
          'add' => NULL,
        ],
        'identifier' => [
          'name' => 'identifier',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Identifier'),
          'description' => E::ts('An identifier that we can use in CiviCRM to find the paymentIntent if we do not have the ID (eg. session key)'),
          'required' => FALSE,
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_stripe_paymentintent.identifier',
          'table_name' => 'civicrm_stripe_paymentintent',
          'entity' => 'StripePaymentintent',
          'bao' => 'CRM_Stripe_DAO_StripePaymentintent',
          'localizable' => 0,
          'add' => NULL,
        ],
        'contact_id' => [
          'name' => 'contact_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('Contact ID'),
          'description' => E::ts('FK to Contact'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_stripe_paymentintent.contact_id',
          'table_name' => 'civicrm_stripe_paymentintent',
          'entity' => 'StripePaymentintent',
          'bao' => 'CRM_Stripe_DAO_StripePaymentintent',
          'localizable' => 0,
          'FKClassName' => 'CRM_Contact_DAO_Contact',
          'add' => NULL,
        ],
        'created_date' => [
          'name' => 'created_date',
          'type' => CRM_Utils_Type::T_TIMESTAMP,
          'title' => E::ts('Created Date'),
          'description' => E::ts('When was paymentIntent created'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_stripe_paymentintent.created_date',
          'default' => 'CURRENT_TIMESTAMP',
          'table_name' => 'civicrm_stripe_paymentintent',
          'entity' => 'StripePaymentintent',
          'bao' => 'CRM_Stripe_DAO_StripePaymentintent',
          'localizable' => 0,
          'add' => NULL,
        ],
        'flags' => [
          'name' => 'flags',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Flags'),
          'description' => E::ts('Flags associated with this PaymentIntent (NC=no contributionID when doPayment called)'),
          'required' => FALSE,
          'maxlength' => 100,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_stripe_paymentintent.flags',
          'table_name' => 'civicrm_stripe_paymentintent',
          'entity' => 'StripePaymentintent',
          'bao' => 'CRM_Stripe_DAO_StripePaymentintent',
          'localizable' => 0,
          'add' => NULL,
        ],
        'referrer' => [
          'name' => 'referrer',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Referrer'),
          'description' => E::ts('HTTP referrer of this paymentIntent'),
          'required' => FALSE,
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_stripe_paymentintent.referrer',
          'table_name' => 'civicrm_stripe_paymentintent',
          'entity' => 'StripePaymentintent',
          'bao' => 'CRM_Stripe_DAO_StripePaymentintent',
          'localizable' => 0,
          'add' => NULL,
        ],
        'extra_data' => [
          'name' => 'extra_data',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Extra Data'),
          'description' => E::ts('Extra data collected to help with diagnostics (such as email, name)'),
          'required' => FALSE,
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_stripe_paymentintent.extra_data',
          'table_name' => 'civicrm_stripe_paymentintent',
          'entity' => 'StripePaymentintent',
          'bao' => 'CRM_Stripe_DAO_StripePaymentintent',
          'localizable' => 0,
          'add' => NULL,
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, 'stripe_paymentintent', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, 'stripe_paymentintent', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [
      'UI_stripe_intent_id' => [
        'name' => 'UI_stripe_intent_id',
        'field' => [
          0 => 'stripe_intent_id',
        ],
        'localizable' => FALSE,
        'unique' => TRUE,
        'sig' => 'civicrm_stripe_paymentintent::1::stripe_intent_id',
      ],
    ];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
